<template>
  <div class="json-renderer--line tree-item">
    <input
      v-if="hasChildren"
      type="checkbox"
      :id="'tree-item--' + fullIndexPath"
      class="u-hide"
      @change="toggled = !toggled"
    />
    <label v-if="hasChildren" class="toggle-label" :for="'tree-item--' + fullIndexPath">
      <div class="json-renderer--level-toggle">
        <div>{{ (!toggled) ? '+' : '-' }}</div>
      </div>
    </label>

    <div v-if="!hasChildren" class="json-renderer--level-toggle"></div>

    <JsonRendererValue :value="keyName" />
    <div class="json-renderer--keyvalue-seperator">:</div>
    <JsonRendererValue :value="value" />

    <div v-if="hasChildren" class="tree-item-body">
      <JsonRendererLevel :class="''" :json="value" :indexPath="fullIndexPath" />
    </div>
  </div>
</template>

<script>
import JsonRendererValue from "./Value.vue";

export default {
  name: "JsonRendererLine",
  props: {
    keyName: null,
    value: null,
    index: Number,
    indexPath: String,
  },
  components: {
    JsonRendererValue: JsonRendererValue,
  },
  data() {
    return {
      toggled: false,
    };
  },
  computed: {
    hasChildren() {
      if (typeof this.value == "array") {
        return true;
      }
      if (typeof this.value == "object") {
        return true;
      }
      return false;
    },
    fullIndexPath() {
      if (!this.indexPath) {
        return this.index + "";
      }
      return this.indexPath + "-" + this.index;
    },
  },
};
</script>

<style lang="css">
.json-renderer--line {
  font-family: monospace;
}

.json-renderer--value,
.json-renderer--keyvalue-seperator,
.json-renderer--level-toggle {
  display: inline-block;
}

.json-renderer--level-toggle {
  line-height: 1.5rem;
  width: 1.5rem;
  text-align: center;
}

label:not(:first-child):not(:last-child):not(.form-group-label) {
  margin: 0;
}
</style>
